//
//  WirelessViewController.m
//  fatSoilDemo
//
//  Created by mc on 17/9/11.
//  Copyright © 2017年 mc. All rights reserved.
//

#import "WiredViewController.h"
#import <SystemConfiguration/CaptiveNetwork.h>
#import <MobileCoreServices/UTCoreTypes.h>
#import "GCDAsyncSocket.h"
#import "ConnectWiFiViewController.h"

#define iOS10 ([[UIDevice currentDevice].systemVersion doubleValue] >= 10.0)
@interface WiredViewController ()<UIAlertViewDelegate,GCDAsyncSocketDelegate,UITextFieldDelegate>


@property (weak, nonatomic) IBOutlet UITextField *ip;
@property (weak, nonatomic) IBOutlet UITextField *gateWay;
@property (weak, nonatomic) IBOutlet UITextField *dns;
@property (nonatomic, strong)GCDAsyncSocket *clientSocket;

@end

@implementation WiredViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.navigationItem.title=@"有线配置";

    self.ip.delegate=self;
    self.gateWay.delegate=self;
    self.dns.delegate=self;
}


-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"提示" message:@"请先前往wifi连接界面连接设备wifi" preferredStyle:UIAlertControllerStyleAlert];
    UIAlertAction *cancelAction = [UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleCancel handler:nil];
    UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
        
        //前往wifi列表
        NSString * urlString = @"App-Prefs:root=WIFI";
        if ([[UIApplication sharedApplication] canOpenURL:[NSURL URLWithString:urlString]]) {
            if (iOS10) {
                [[UIApplication sharedApplication] openURL:[NSURL URLWithString:urlString] options:@{} completionHandler:nil];
            } else {
                [[UIApplication sharedApplication] openURL:[NSURL URLWithString:@"prefs:root=WIFI"]];
            }
        }
        
    }];
    [alertController addAction:cancelAction];
    [alertController addAction:okAction];
    [self presentViewController:alertController animated:YES completion:nil];
}

//键盘退出

-(BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [_ip resignFirstResponder];
    [_gateWay resignFirstResponder];
    [_dns resignFirstResponder];
    return NO;
}
//下一步
- (IBAction)nextBt:(id)sender {
    
    //配置静态ip时，dns是可以不填写的 默认是8.8.8.8,如果填写了就以填写的为准；如果是配置动态ip，则IP地址，网关，dns都为空即可
    
        if ((_ip.text.length > 0||_gateWay.text.length > 0)&&_dns.text.length==0) {
            _dns.text = @"8.8.8.8";
        }
    
        if ((_ip.text.length==0&&_gateWay.text.length==0&&_dns.text.length== 0)||(_ip.text.length!=0&&_gateWay.text.length!=0&&_dns.text.length != 0)) {
            if (_ip.text.length!=0&&_gateWay.text.length!=0&&_dns.text.length != 0) {
                
                
                if (![self isValidatIP:_ip.text]) {
                    
                    UIAlertView *alertView=[[UIAlertView alloc]initWithTitle:@"提示" message:@"请输入正常的ip地址" delegate:self cancelButtonTitle:nil otherButtonTitles:@"确定", nil];
                    [alertView show];
                    return;
                }
                else if (![self isValidatIP:_dns.text]) {
                    
                    UIAlertView *alertView=[[UIAlertView alloc]initWithTitle:@"提示" message:@"请输入正常的dns地址" delegate:self cancelButtonTitle:nil otherButtonTitles:@"确定", nil];
                    
                    [alertView show];
                    return;
                }else if (![self isValidatIP:_gateWay.text]) {
                    
                    UIAlertView *alertView=[[UIAlertView alloc]initWithTitle:@"提示" message:@"请输入正常的网关地址" delegate:self cancelButtonTitle:nil otherButtonTitles:@"确定", nil];
                    
                    [alertView show];
                    return;
                }
            }
            
           
            if (_gateWay.text == nil) {
                _gateWay.text = @"";
            }
            if (_ip.text == nil) {
                _ip.text = @"";
            }
            if (_dns.text == nil) {
                _dns.text = @"";
            }
            
            //2.链接服务器socket 192.168.0.113为服务端IP
            self.clientSocket = [[GCDAsyncSocket alloc] initWithDelegate:self delegateQueue:dispatch_get_main_queue()];
            
            BOOL result = [self.clientSocket connectToHost:@"192.168.43.1" onPort:5000 error:nil];
            //判断链接
            if (result) {
                //成功
                //给服务端发送消息
                NSMutableDictionary *params = [NSMutableDictionary dictionaryWithCapacity:2];
                
                
                [params setObject:_ip.text forKey:@"ipAddress"];
                [params setObject:_gateWay.text forKey:@"gateWay"];
                [params setObject:_dns.text forKey:@"dns"];
                
                if (_ip.text.length==0&&_gateWay.text.length==0&&_dns.text.length==0) {
                    [params setObject:@"false"forKey:@"isStatic"];//动态
                    
                }else{
                    [params setObject:@"true" forKey:@"isStatic"];//静态IP
                    
                }
                
                [params setObject:@"true" forKey:@"isEthernet"];//是否是以太网配置 不是
                
                
                NSData *data=[NSJSONSerialization dataWithJSONObject:params options:nil error:nil];
                [self.clientSocket writeData:data withTimeout:-1 tag:0];
                
                NSLog(@"链接成功");
                //                UIAlertView *alertView=[[UIAlertView alloc]initWithTitle:@"提示" message:@"与设备连接成功可以通讯" delegate:self cancelButtonTitle:nil otherButtonTitles:@"确定", nil];
                //                self.jump=0;
                //
                //                [alertView show];
                
                
            }
            else{
                //失败
                NSLog(@"链接失败");
            }
            
            
        }
        else{
            
            UIAlertView *alertView=[[UIAlertView alloc]initWithTitle:@"提示" message:@"请输入必填的ip地址和必填的网关地址" delegate:self cancelButtonTitle:nil otherButtonTitles:@"确定", nil];
            
            [alertView show];
            
        }
        
        
        
        
 
 
    
}


//正则判断ip，dns，网关地址
-(BOOL)isValidatIP:(NSString *)ipAddress{
    
    NSString  *urlRegEx =@"^([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\."
    "([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\."
    "([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\."
    "([01]?\\d\\d?|2[0-4]\\d|25[0-5])$";
    
    NSError *error;
    NSRegularExpression *regex = [NSRegularExpression regularExpressionWithPattern:urlRegEx options:0 error:&error];
    
    if (regex != nil) {
        NSTextCheckingResult *firstMatch=[regex firstMatchInString:ipAddress options:0 range:NSMakeRange(0, [ipAddress length])];
        
        if (firstMatch) {
            NSRange resultRange = [firstMatch rangeAtIndex:0];
            NSString *result=[ipAddress substringWithRange:resultRange];
            //输出结果
            NSLog(@"%@",result);
            return YES;
        }
    }
    
    return NO;
}
#pragma mark ------------socket连接代理方法

- (void)socketDidDisconnect:(GCDAsyncSocket *)sock withError:(nullable NSError *)err
{
    UIAlertView *alert=[[UIAlertView alloc]initWithTitle:nil message:@"设备连接中断" delegate:self cancelButtonTitle:nil otherButtonTitles:@"确定", nil];
    
    [alert show];
}




//客户端链接服务器成功
- (void)socket:(GCDAsyncSocket *)sock didConnectToHost:(NSString *)host port:(uint16_t)port{
    
    NSLog(@"%@",[NSString stringWithFormat:@"链接成功服务器：%@",host]);
    ConnectWiFiViewController *conVC=[[ConnectWiFiViewController alloc]init];
    [self showViewController:conVC sender:nil];
    
    [self.clientSocket readDataWithTimeout:-1 tag:0];
}

//成功读取服务端发过来的消息
- (void)socket:(GCDAsyncSocket *)sock didReadData:(NSData *)data withTag:(long)tag{
    
    NSLog(@"读取服务端发过来的消息 = %@",[[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding]);
    
    [self.clientSocket readDataWithTimeout:-1 tag:0];
}

- (void)viewDidDisappear:(BOOL)animated {
    [super viewDidDisappear:animated];
    [self.clientSocket setDelegate:nil delegateQueue:nil];
    [self.clientSocket disconnect];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
